unit unit1laz;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, FileUtil, Forms, Controls, Graphics, Dialogs, ExtCtrls,
  StdCtrls;

type

  { TForm1 }

  TForm1 = class(TForm)
    Button1: TButton;
    Image1: TImage;
    OpenDialog1: TOpenDialog;
    Panel1: TPanel;
    ScrollBox1: TScrollBox;
    procedure Button1Click(Sender: TObject);
    procedure OpenJPEG(nam: string);
    procedure FormShow(Sender: TObject);
  private

  public

  end;

var
  Form1: TForm1;

implementation

{$R *.lfm}

uses NanoJpeg;

procedure TForm1.Button1Click(Sender: TObject);
begin
       if not OpenDialog1.Execute then exit;
       OpenJPEG(OpenDialog1.Filename);
end;


procedure DrawBMP( lx, ly: integer; var P : PByte; var lImage: TImage);
var
   B : TBitmap;
   I,J : integer;
begin
  B := TBitmap.Create;
  //B.PixelFormat := pf32bit;
  B.Width := lx;//D.GetWidth;
  B.Height := ly;//D.GetHeight;
  for I := 0 to B.Height-1 do
    for J := 0 to B.Width - 1 do
      begin
        {$IFDEF FPC}
        B.Canvas.Pixels[J,I] := RGBToColor(P[0],P[1],P[2]);
        {$ELSE}
        B.Canvas.Pixels[J,I] := RGB(P[0],P[1],P[2]);
        {$ENDIF}
        Inc(P,3);
      end;
  lImage.Picture.Assign(B); //Image1.Picture.Assign(B);
  B.Free;
end;

procedure TForm1.OpenJPEG(nam: string);
var
  M : TMemoryStream;
  D : TNjDecoder;
  P : PByte;
begin
  if not fileexists(nam) then begin
     showmessage('Unable to find ' + nam);
     exit;
  end;
  M := TMemoryStream.Create;
  try
    M.LoadFromFile(nam );
    M.Position := 0;
    D := TNjDecoder.Create;
    try
      if not D.Decode(M.Memory,M.Size) then
        showmessage('Decoding Failed')
      else
      begin
         P := D.GetImage;
         DrawBMP(D.GetWidth, D.GetHeight, P, Image1);
      end;
    finally
      D.Free;
    end;
  finally
    M.Free;
  end;
end;

procedure TForm1.FormShow(Sender: TObject);
begin
  //OpenJPEG('~/Desktop/test.jpg');
end;

end.

